<template>
  <div class="header shadow-5">
    <div class="container">
      <div class="flex justify-between items-center q-mb-md">
        <div class="flex items-center">
          <span class="q-mr-md">Kết nối</span>
          <q-btn flat dense icon="fab fa-facebook" color="blue-8" />
          <q-btn flat dense icon="fab fa-instagram" color="pink-8" />
          <q-btn flat dense icon="fab fa-youtube" color="red-8" />
        </div>
        <div>
          <span>
            Xin chào,
            <router-link
              to="/user"
              tag="strong"
              class="cursor-pointer text-primary text-bold"
            >{{user.fullName}}</router-link>&nbsp;&nbsp;|&nbsp;&nbsp;
          </span>
          <span class="cursor-pointer text-primary text-bold" @click="logout()">Đăng xuất</span>
        </div>
      </div>
      <div class="flex justify-between items-center">
        <router-link to="/" tag="div" class="cursor-pointer">
          <q-avatar square size="60px">
            <img src="~/assets/logo.png" />
          </q-avatar>
        </router-link>
        <div style="flex: 1" class="q-mx-md-xl q-mx-sm-md q-mx-sm">
          <q-form>
            <q-input outlined dense v-model="searchText" class="search">
              <template v-slot:append>
                <q-btn type="submit" unelevated icon="search" color="primary" @click="onSearch" />
              </template>
            </q-input>
          </q-form>
        </div>
        <div>
          <notification />
          <shopping-cart />
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { mapState, mapActions } from 'vuex';
import Notification from '~/components/user/ModalNotification.vue';
import ShoppingCart from '~/components/user/ShoppingCart.vue';

export default {
  components: { Notification, ShoppingCart },
  data() {
    return {
      searchText: ''
    };
  },
  computed: {
    ...mapState({
      user: state => state.auth.user
    })
  },
  methods: {
    ...mapActions({
      logout: 'auth/logout'
    }),
    onSearch() {
      this.$router.push(`/search?query=${encodeURIComponent(this.searchText)}`);
    }
  }
};
</script>

<style lang="scss" scoped>
.header {
  background: white;
  padding: 10px 0 20px 0;
  position: sticky;
  position: -webkit-sticky;
  top: 0;
  z-index: 999;
}

.search {
  /deep/ .q-field__control {
    padding-right: 0 !important;

    .q-field__append {
      button {
        height: 100%;
      }
    }
  }
}
</style>
